# PAX - the Pythonic API for XML
# developed by Lalo Martins <lalo@laranja.org>
# this file is placed on public domain

from xml.sax.saxutils import escape

def XML(obj, ns_map={}):
    try:
        # PAX object, or anything that can render itself into xml?
        return obj.__xml__(ns_map)
    except AttributeError:
        pass
    try:
        # string or unicode?
        return escape(unicode(obj))
    except TypeError:
        pass
    try:
        # sequence?
        return ''.join([XML(child, ns_map) for child in obj])
    except TypeError:
        pass
    # I give up! Coerce it to string and return it...
    return escape(unicode(str(obj)))

